/*
 * Ported from Flashlight VNC ActionScript implementation:
 *     http://www.wizhelp.com/flashlight-vnc/
 *
 * Full attribution follows:
 *
 * -------------------------------------------------------------------------
 *
 * This DES class has been extracted from package Acme.Crypto for use in VNC.
 * The unnecessary odd parity code has been removed.
 *
 * These changes are:
 *  Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *

 * DesCipher - the DES encryption method
 *
 * The meat of this code is by Dave Zimmerman <dzimm@widget.com>, and is:
 *
 * Copyright (c) 1996 Widget Workshop, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted, provided that this copyright notice is kept 
 * intact. 
 * 
 * WIDGET WORKSHOP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WIDGET WORKSHOP SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  WIDGET WORKSHOP
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 *
 * The rest is:
 *
 * Copyright (C) 1996 by Jef Poskanzer <jef@acme.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the ACME Labs Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.acme.com/java/
 */
"use strict";function DES(e){function t(e){var t,n,a,l,o,r,s,i,u,d,c=[],p=[],h=[];for(n=0,a=56;56>n;++n,a-=8)a+=-5>a?65:-3>a?31:-1>a?63:27===a?35:0,l=7&a,c[n]=0!==(e[a>>>3]&1<<l)?1:0;for(t=0;16>t;++t){for(l=t<<1,o=l+1,h[l]=h[o]=0,r=28;59>r;r+=28)for(n=r-28;r>n;++n)a=n+y[t],p[n]=r>a?c[a]:c[a-28];for(n=0;24>n;++n)0!==p[b[n]]&&(h[l]|=1<<23-n),0!==p[b[n+24]]&&(h[o]|=1<<23-n)}for(t=0,u=0,d=0;16>t;++t)s=h[u++],i=h[u++],A[d]=(16515072&s)<<6,A[d]|=(4032&s)<<10,A[d]|=(16515072&i)>>>10,A[d]|=(4032&i)>>>6,++d,A[d]=(258048&s)<<12,A[d]|=(63&s)<<16,A[d]|=(258048&i)>>>4,A[d]|=63&i,++d}function n(e){var t,n,a,l,o=0,r=e.slice(),s=0;for(n=r[o++]<<24|r[o++]<<16|r[o++]<<8|r[o++],a=r[o++]<<24|r[o++]<<16|r[o++]<<8|r[o++],l=252645135&(n>>>4^a),a^=l,n^=l<<4,l=65535&(n>>>16^a),a^=l,n^=l<<16,l=858993459&(a>>>2^n),n^=l,a^=l<<2,l=16711935&(a>>>8^n),n^=l,a^=l<<8,a=a<<1|a>>>31&1,l=2863311530&(n^a),n^=l,a^=l,n=n<<1|n>>>31&1,o=0;8>o;++o)l=a<<28|a>>>4,l^=A[s++],t=g[63&l],t|=m[l>>>8&63],t|=p[l>>>16&63],t|=d[l>>>24&63],l=a^A[s++],t|=v[63&l],t|=f[l>>>8&63],t|=h[l>>>16&63],t|=c[l>>>24&63],n^=t,l=n<<28|n>>>4,l^=A[s++],t=g[63&l],t|=m[l>>>8&63],t|=p[l>>>16&63],t|=d[l>>>24&63],l=n^A[s++],t|=v[63&l],t|=f[l>>>8&63],t|=h[l>>>16&63],t|=c[l>>>24&63],a^=t;for(a=a<<31|a>>>1,l=2863311530&(n^a),n^=l,a^=l,n=n<<31|n>>>1,l=16711935&(n>>>8^a),a^=l,n^=l<<8,l=858993459&(n>>>2^a),a^=l,n^=l<<2,l=65535&(a>>>16^n),n^=l,a^=l<<16,l=252645135&(a>>>4^n),n^=l,a^=l<<4,l=[a,n],o=0;8>o;o++)r[o]=(l[o>>>2]>>>8*(3-o%4))%256,r[o]<0&&(r[o]+=256);return r}function a(e){return n(e.slice(0,8)).concat(n(e.slice(8,16)))}var l,o,r,s,i,u,d,c,p,h,m,f,g,v,b=[13,16,10,23,0,4,2,27,14,5,20,9,22,18,11,3,25,7,15,6,26,19,12,1,40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,28,31],y=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],w=0,A=[];return l=65536,o=1<<24,r=l|o,s=4,i=1024,u=s|i,d=[r|i,w|w,l|w,r|u,r|s,l|u,w|s,l|w,w|i,r|i,r|u,w|i,o|u,r|s,o|w,w|s,w|u,o|i,o|i,l|i,l|i,r|w,r|w,o|u,l|s,o|s,o|s,l|s,w|w,w|u,l|u,o|w,l|w,r|u,w|s,r|w,r|i,o|w,o|w,w|i,r|s,l|w,l|i,o|s,w|i,w|s,o|u,l|u,r|u,l|s,r|w,o|u,o|s,w|u,l|u,r|i,w|u,o|i,o|i,w|w,l|s,l|i,w|w,r|s],l=1<<20,o=1<<31,r=l|o,s=32,i=32768,u=s|i,c=[r|u,o|i,w|i,l|u,l|w,w|s,r|s,o|u,o|s,r|u,r|i,o|w,o|i,l|w,w|s,r|s,l|i,l|s,o|u,w|w,o|w,w|i,l|u,r|w,l|s,o|s,w|w,l|i,w|u,r|i,r|w,w|u,w|w,l|u,r|s,l|w,o|u,r|w,r|i,w|i,r|w,o|i,w|s,r|u,l|u,w|s,w|i,o|w,w|u,r|i,l|w,o|s,l|s,o|u,o|s,l|s,l|i,w|w,o|i,w|u,o|w,r|s,r|u,l|i],l=1<<17,o=1<<27,r=l|o,s=8,i=512,u=s|i,p=[w|u,r|i,w|w,r|s,o|i,w|w,l|u,o|i,l|s,o|s,o|s,l|w,r|u,l|s,r|w,w|u,o|w,w|s,r|i,w|i,l|i,r|w,r|s,l|u,o|u,l|i,l|w,o|u,w|s,r|u,w|i,o|w,r|i,o|w,l|s,w|u,l|w,r|i,o|i,w|w,w|i,l|s,r|u,o|i,o|s,w|i,w|w,r|s,o|u,l|w,o|w,r|u,w|s,l|u,l|i,o|s,r|w,o|u,w|u,r|w,l|u,w|s,r|s,l|i],l=8192,o=1<<23,r=l|o,s=1,i=128,u=s|i,h=[r|s,l|u,l|u,w|i,r|i,o|u,o|s,l|s,w|w,r|w,r|w,r|u,w|u,w|w,o|i,o|s,w|s,l|w,o|w,r|s,w|i,o|w,l|s,l|i,o|u,w|s,l|i,o|i,l|w,r|i,r|u,w|u,o|i,o|s,r|w,r|u,w|u,w|w,w|w,r|w,l|i,o|i,o|u,w|s,r|s,l|u,l|u,w|i,r|u,w|u,w|s,l|w,o|s,l|s,r|i,o|u,l|s,l|i,o|w,r|s,w|i,o|w,l|w,r|i],l=1<<25,o=1<<30,r=l|o,s=256,i=1<<19,u=s|i,m=[w|s,l|u,l|i,r|s,w|i,w|s,o|w,l|i,o|u,w|i,l|s,o|u,r|s,r|i,w|u,o|w,l|w,o|i,o|i,w|w,o|s,r|u,r|u,l|s,r|i,o|s,w|w,r|w,l|u,l|w,r|w,w|u,w|i,r|s,w|s,l|w,o|w,l|i,r|s,o|u,l|s,o|w,r|i,l|u,o|u,w|s,l|w,r|i,r|u,w|u,r|w,r|u,l|i,w|w,o|i,r|w,w|u,l|s,o|s,w|i,w|w,o|i,l|u,o|s],l=1<<22,o=1<<29,r=l|o,s=16,i=16384,u=s|i,f=[o|s,r|w,w|i,r|u,r|w,w|s,r|u,l|w,o|i,l|u,l|w,o|s,l|s,o|i,o|w,w|u,w|w,l|s,o|u,w|i,l|i,o|u,w|s,r|s,r|s,w|w,l|u,r|i,w|u,l|i,r|i,o|w,o|i,w|s,r|s,l|i,r|u,l|w,w|u,o|s,l|w,o|i,o|w,w|u,o|s,r|u,l|i,r|w,l|u,r|i,w|w,r|s,w|s,w|i,r|w,l|u,w|i,l|s,o|u,w|w,r|i,o|w,l|s,o|u],l=1<<21,o=1<<26,r=l|o,s=2,i=2048,u=s|i,g=[l|w,r|s,o|u,w|w,w|i,o|u,l|u,r|i,r|u,l|w,w|w,o|s,w|s,o|w,r|s,w|u,o|i,l|u,l|s,o|i,o|s,r|w,r|i,l|s,r|w,w|i,w|u,r|u,l|i,w|s,o|w,l|i,o|w,l|i,l|w,o|u,o|u,r|s,r|s,w|s,l|s,o|w,o|i,l|w,r|i,w|u,l|u,r|i,w|u,o|s,r|u,r|w,l|i,w|w,w|s,r|u,w|w,l|u,r|w,w|i,o|s,o|i,w|i,l|s],l=1<<18,o=1<<28,r=l|o,s=64,i=4096,u=s|i,v=[o|u,w|i,l|w,r|u,o|w,o|u,w|s,o|w,l|s,r|w,r|u,l|i,r|i,l|u,w|i,w|s,r|w,o|s,o|i,w|u,l|i,l|s,r|s,r|i,w|u,w|w,w|w,r|s,o|s,o|i,l|u,l|w,l|u,l|w,r|i,w|i,w|s,r|s,w|i,l|u,o|i,w|s,o|s,r|w,r|s,o|w,l|w,o|u,w|w,r|u,l|s,o|s,r|w,o|i,o|u,w|w,r|u,l|i,l|i,w|u,w|u,l|s,o|w,r|i],t(e),{encrypt:a}}