/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return T}function t(){return k}function n(){return x}function a(e){x=e}function l(){return k.length-x}function o(){return k[x]}function r(){return k[x++]}function s(e){0===x?k.unshift(e):(x-=1,k[x]=e)}function i(){return(k[x++]<<8)+k[x++]}function u(){return(k[x++]<<24)+(k[x++]<<16)+(k[x++]<<8)+k[x++]}function d(e){"undefined"==typeof e&&(e=l());var t=k.slice(x,x+e);return x+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function c(e){return"undefined"==typeof e&&(e=l()),x+=e,k.slice(x-e,x)}function p(e,t){return t?k.slice(x+e,x+t):k.slice(x+e)}function h(e,t,n){var a=k.length-x;if(t>a){if(n){if(n>x)throw"rQwait cannot backup "+n+" bytes";x-=n}return!0}return!1}function m(){return Base64.encode(T)}function f(e){k=k.concat(Base64.decode(e,0))}function g(){return 0!==E.bufferedAmount&&Util.Debug("bufferedAmount: "+E.bufferedAmount),E.bufferedAmount<P.maxBufferedAmount?(T.length>0&&(E.send(m(T)),T=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+E.bufferedAmount),!1)}function v(e){return T=T.concat(e),g()}function b(e){P.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),l()>0?(I.message(),k.length>F&&(k=k.slice(x),x=0)):Util.Debug("Ignoring empty message")}catch(t){Util.Warn("undefined"!=typeof t.stack?"recv_message, caught exception: "+t.stack:"undefined"!=typeof t.description?"recv_message, caught exception: "+t.description:"recv_message, caught exception:"+t),I.error("undefined"!=typeof t.name?t.name+": "+t.message:t)}}function w(e,t){I[e]=t}function A(){k=[],x=0,T=[],E=null}function C(e){A(),E=N?{}:new WebSocket(e,"base64"),E.onmessage=y,E.onopen=function(){Util.Debug(">> WebSock.onopen"),E.protocol&&Util.Info("Server chose sub-protocol: "+E.protocol),I.open(),Util.Debug("<< WebSock.onopen")},E.onclose=function(e){Util.Debug(">> WebSock.onclose"),I.close(e),Util.Debug("<< WebSock.onclose")},E.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),I.error(e),Util.Debug("<< WebSock.onerror")}}function S(){E&&((E.readyState===WebSocket.OPEN||E.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),E.close()),E.onmessage=function(){})}function _(e){return N=!0,P.send=e,P.close=function(){},y}function D(){return P.maxBufferedAmount=200,P.get_sQ=e,P.get_rQ=t,P.get_rQi=n,P.set_rQi=a,P.rQlen=l,P.rQpeek8=o,P.rQshift8=r,P.rQunshift8=s,P.rQshift16=i,P.rQshift32=u,P.rQshiftStr=d,P.rQshiftBytes=c,P.rQslice=p,P.rQwait=h,P.flush=g,P.send=v,P.send_string=b,P.on=w,P.init=A,P.open=C,P.close=S,P.testMode=_,P}var P={},E=null,k=[],x=0,F=1e4,T=[],I={message:function(){},open:function(){},close:function(){},error:function(){}},N=!1;return D()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",a="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),a+=t+"web-socket-js/swfobject.js"+n,a+=t+"web-socket-js/web_socket.js"+n,document.write(a)}());