/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 *
 * TIGHT decoder portion:
 * (c) 2012 Michael Tinglof, Joe Balaz, Les Piech (Mercuri.ca)
 */
function RFB(e){"use strict";function t(){var e,t;for(Util.Debug(">> RFB.constructor"),e=0;e<U.length;e+=1)O[U[e][1]]=O[U[e][0]],z[U[e][1]]=U[e][0],$[U[e][1]]=[0,0];try{V=new Display({target:k.target})}catch(n){Util.Error("Display exception: "+n),s("fatal","No working Display")}return q=new Keyboard({target:k.focusContainer,onKeyPress:_}),G=new Mouse({target:k.target,onMouseButton:D,onMouseMove:P}),t=V.get_render_mode(),H=new Websock,H.on("message",u),H.on("open",function(){"connect"===L?s("ProtocolVersion","Starting VNC handshake"):i("Got unexpected WebSockets connection")}),H.on("close",function(e){e.code&&Util.Info("Close code: "+e.code+", reason: "+e.reason+", wasClean: "+e.wasClean),"disconnect"===L?s("disconnected","VNC disconnected"):"ProtocolVersion"===L?i("Failed to connect to server"):L in{failed:1,disconnected:1}?Util.Error("Received onclose while disconnected"):i("Server disconnected")}),H.on("error",function(e){i("WebSock error: "+e)}),r(),Websock_native?(Util.Info("Using native WebSockets"),s("loaded","noVNC ready: native WebSockets, "+t)):(Util.Warn("Using web-socket-js bridge. Flash version: "+Util.Flash.version),!Util.Flash||Util.Flash.version<9?s("fatal","WebSockets or <a href='http://get.adobe.com/flashplayer'>Adobe Flash</a> is required"):"file://"===document.location.href.substr(0,7)?s("fatal","'file://' URL is incompatible with Adobe Flash"):s("loaded","noVNC ready: WebSockets emulation, "+t)),Util.Debug("<< RFB.constructor"),x}function n(){Util.Debug(">> RFB.connect");var e;"undefined"!=typeof UsingSocketIO?e="http://"+F+":"+T+"/"+N:(e=k.encrypt?"wss://":"ws://",e+=F+":"+T+"/"+N),Util.Info("connecting to "+e),H.open(e),Util.Debug("<< RFB.connect")}function a(e,t){var n,a=[];for(n=0;n<e.length;n+=1)a.push(e.charCodeAt(n));return new DES(a).encrypt(t)}function l(){return ut.length>0?(H.send(ut),setTimeout(function(){H.send(v())},50),ut=[],!0):!1}function o(e){1===Z&&i("Tight protocol handler only implements true color mode");var t,n,a,l,o,r,s=-1,u=0,d=-1,c=H.get_rQ(),p=H.get_rQi();if(Q.bytes=1,H.rQwait("TIGHT compression-control",Q.bytes))return!1;var h=function(e){for(var t=0;4>t;t++)u>>t&1&&(Q.zlibs[t].reset(),Util.Info("Reset zlib stream "+t));var n=Q.zlibs[d].uncompress(e,0);return 0!==n.status&&Util.Error("Invalid data in zlib stream"),n.data},m=function(){var e=c[p+2]+1,t=e*Z;if(Q.bytes+=t,H.rQwait("TIGHT palette "+n,Q.bytes))return!1;var l=2>=e?1:8,o=Math.floor((Q.width*l+7)/8),s=!1;if(o*Q.height<12?(s=!0,a=[0,o*Q.height]):a=A(H.rQslice(3+t,3+t+3)),Q.bytes+=a[0]+a[1],H.rQwait("TIGHT "+n,Q.bytes))return!1;H.rQshiftBytes(3);var i=H.rQshiftBytes(t);H.rQshiftBytes(a[0]),r=s?H.rQshiftBytes(a[1]):h(H.rQshiftBytes(a[1]));var u,d,m,f,g,v,b,y=[];if(2===e)for(f=Math.floor((Q.width+7)/8),g=Math.floor(Q.width/8),d=0;d<Q.height;d++){for(u=0;g>u;u++)for(m=7;m>=0;m--)v=3*(d*Q.width+8*u+7-m),b=3*(r[d*f+u]>>m&1),y[v]=i[b],y[v+1]=i[b+1],y[v+2]=i[b+2];for(m=7;m>=8-Q.width%8;m--)v=3*(d*Q.width+8*u+7-m),b=3*(r[d*f+u]>>m&1),y[v]=i[b],y[v+1]=i[b+1],y[v+2]=i[b+2]}else for(d=0;d<Q.height;d++)for(u=0;u<Q.width;u++)v=3*(d*Q.width+u),b=3*r[d*Q.width+u],y[v]=i[b],y[v+1]=i[b+1],y[v+2]=i[b+2];return Q.imgQ.push({type:"rgb",img:{complete:!0,data:y},x:Q.x,y:Q.y,width:Q.width,height:Q.height}),!0},f=function(){var e=!1,t=Q.width*Q.height*Z;return 12>t?(e=!0,a=[0,t]):a=A(H.rQslice(1,4)),Q.bytes=1+a[0]+a[1],H.rQwait("TIGHT "+n,Q.bytes)?!1:(H.rQshiftBytes(1+a[0]),r=e?H.rQshiftBytes(a[1]):h(H.rQshiftBytes(a[1])),Q.imgQ.push({type:"rgb",img:{complete:!0,data:r},x:Q.x,y:Q.y,width:Q.width,height:Q.height}),!0)};if(t=H.rQpeek8(),u=15&t,t>>=4,d=3&t,8===t)n="fill";else if(9===t)n="jpeg";else if(10===t)n="png";else if(4&t)n="filter";else{if(!(4>t))throw"Illegal tight compression received, ctl: "+t;n="copy"}if(e&&("filter"===n||"copy"===n))throw"filter/copy received in tightPNG mode";switch(n){case"fill":Q.bytes+=Z;break;case"jpeg":Q.bytes+=3;break;case"png":Q.bytes+=3;break;case"filter":Q.bytes+=2;break;case"copy":}if(H.rQwait("TIGHT "+n,Q.bytes))return!1;switch(n){case"fill":H.rQshift8(),l=H.rQshiftBytes(Z),Q.imgQ.push({type:"fill",img:{complete:!0},x:Q.x,y:Q.y,width:Q.width,height:Q.height,color:[l[2],l[1],l[0]]});break;case"png":case"jpeg":if(a=A(H.rQslice(1,4)),Q.bytes=1+a[0]+a[1],H.rQwait("TIGHT "+n,Q.bytes))return!1;H.rQshiftBytes(1+a[0]),o=new Image,Q.imgQ.push({type:"img",img:o,x:Q.x,y:Q.y}),o.src="data:image/"+n+C(H.rQshiftBytes(a[1])),o=null;break;case"filter":if(s=c[p+1],1!==s)throw"Unsupported tight subencoding received, filter: "+s;if(!m())return!1;break;case"copy":if(!f())return!1}return Q.bytes=0,Q.rects-=1,!0}var r,s,i,u,d,c,p,h,m,f,g,v,b,y,w,A,C,S,_,D,P,E,x={},k={},F="",T=5900,I="",N="",L="disconnected",M=0,B=3.8,R="",U=[["COPYRECT",1],["TIGHT",7],["TIGHT_PNG",-260],["HEXTILE",5],["RRE",2],["RAW",0],["DesktopSize",-223],["Cursor",-239],["JPEG_quality_med",-26],["compress_hi",-247],["last_rect",-224]],O={},z={},$={},H=null,V=null,q=null,G=null,j=null,K=null,Y=null,W=null,Q={rects:0,subrects:0,lines:0,tiles:0,bytes:0,x:0,y:0,width:0,height:0,encoding:0,subencoding:-1,background:null,imgQ:[],zlibs:[]},X=4,Z=3,J=0,et=0,tt="",nt=40,at=0,lt=100,ot={last_fbu:0,fbu_total:0,fbu_total_cnt:0,full_fbu_total:0,full_fbu_cnt:0,fbu_rt_start:0,fbu_rt_total:0,fbu_rt_cnt:0,pixels:0},rt=!1,st=Websock_native?10:25,it=0,ut=[],dt=!1,ct={};return Util.conf_defaults(k,x,e,[["target","wo","dom",null,"VNC display rendering Canvas object"],["focusContainer","wo","dom",document,"DOM element that captures keyboard input"],["encrypt","rw","bool",!1,"Use TLS/SSL/wss encryption"],["true_color","rw","bool",!0,"Request true color pixel data"],["local_cursor","rw","bool",!1,"Request locally rendered cursor"],["shared","rw","bool",!0,"Request shared mode"],["view_only","rw","bool",!1,"Disable client mouse/keyboard"],["connectTimeout","rw","int",st,"Time (s) to wait for connection"],["disconnectTimeout","rw","int",10,"Time (s) to wait for disconnection"],["viewportDrag","rw","bool",!1,"Move the viewport on mouse drags"],["check_rate","rw","int",217,"Timing (ms) of send/receive check"],["fbu_req_rate","rw","int",1413,"Timing (ms) of frameBufferUpdate requests"],["onUpdateState","rw","func",function(){},"onUpdateState(rfb, state, oldstate, statusMsg): RFB state update/change "],["onPasswordRequired","rw","func",function(){},"onPasswordRequired(rfb): VNC password is required "],["onClipboard","rw","func",function(){},"onClipboard(rfb, text): RFB clipboard contents received"],["onBell","rw","func",function(){},"onBell(rfb): RFB Bell message received "],["onFBUReceive","rw","func",function(){},"onFBUReceive(rfb, fbu): RFB FBU received but not yet processed "],["onFBUComplete","rw","func",function(){},"onFBUComplete(rfb, fbu): RFB FBU received and processed "],["updateState","rw","func",function(){},"obsolete, use onUpdateState"],["clipboardReceive","rw","func",function(){},"obsolete, use onClipboard"]]),x.set_local_cursor=function(e){!e||e in{0:1,no:1,"false":1}?k.local_cursor=!1:V.get_cursor_uri()?k.local_cursor=!0:Util.Warn("Browser does not support local cursor")},x.get_display=function(){return V},x.get_keyboard=function(){return q},x.get_mouse=function(){return G},r=function(){var e;for(H.init(),Q.rects=0,Q.subrects=0,Q.lines=0,Q.tiles=0,Q.imgQ=[],Q.zlibs=[],it=0,ut=[],e=0;e<U.length;e+=1)$[U[e][1]][0]=0;for(e=0;4>e;e++)Q.zlibs[e]=new TINF,Q.zlibs[e].init()},h=function(){var e,t;for(Util.Info("Encoding stats for this connection:"),e=0;e<U.length;e+=1)t=$[U[e][1]],t[0]+t[1]>0&&Util.Info("    "+U[e][0]+": "+t[0]+" rects");for(Util.Info("Encoding stats since page load:"),e=0;e<U.length;e+=1)t=$[U[e][1]],t[0]+t[1]>0&&Util.Info("    "+U[e][0]+": "+t[1]+" rects")},s=function(e,t){var a,l,o=L;if(e===o)return void Util.Debug("Already in state '"+e+"', ignoring.");switch(e in{disconnected:1,loaded:1,connect:1,disconnect:1,failed:1,fatal:1}&&(j&&(clearInterval(j),j=null),W&&(clearInterval(W),W=null),V&&V.get_context()&&(q.ungrab(),G.ungrab(),V.defaultCursor(),("debug"!==Util.get_logging()||"loaded"===e)&&V.clear()),H.close()),"fatal"===o&&Util.Error("Fatal error, cannot continue"),a="failed"===e||"fatal"===e?Util.Error:Util.Warn,L="failed"===o&&"disconnected"===e?"failed":e,l="undefined"!=typeof t?" Msg: "+t:"",a("New state '"+L+"', was '"+o+"'."+l),K&&"connect"!==L&&(Util.Debug("Clearing connect timer"),clearInterval(K),K=null),Y&&"disconnect"!==L&&(Util.Debug("Clearing disconnect timer"),clearInterval(Y),Y=null),e){case"normal":("disconnected"===o||"failed"===o)&&Util.Error("Invalid transition from 'disconnected' or 'failed' to 'normal'");break;case"connect":K=setTimeout(function(){i("Connect timeout")},1e3*k.connectTimeout),r(),n();break;case"disconnect":rt||(Y=setTimeout(function(){i("Disconnect timeout")},1e3*k.disconnectTimeout)),h();break;case"failed":"disconnected"===o&&Util.Error("Invalid transition from 'disconnected' to 'failed'"),"normal"===o&&Util.Error("Error while connected."),"init"===o&&Util.Error("Error while initializing."),setTimeout(function(){s("disconnected")},50)}"failed"===o&&"disconnected"===e?(k.updateState(x,e,o),k.onUpdateState(x,e,o)):(k.updateState(x,e,o,t),k.onUpdateState(x,e,o,t))},i=function(e){return s("failed",e),!1},u=function(){if(0===H.rQlen())return void Util.Warn("handle_message called on empty receive queue");switch(L){case"disconnected":case"failed":Util.Error("Got data while disconnected");break;case"normal":c()&&H.rQlen()>0&&(null===W?(Util.Debug("More data to process, creating timer"),W=setTimeout(function(){W=null,u()},10)):Util.Debug("More data to process, existing timer"));break;default:d()}},E=function(){var e;"normal"!==L||dt||l()||(e=(new Date).getTime(),e>at+k.fbu_req_rate&&(at=e,H.send(v()))),setTimeout(E,k.check_rate)},_=function(e,t){var n;k.view_only||(n=b(e,t),n=n.concat(v()),H.send(n))},D=function(e,t,n,a){if(n?it|=a:it^=a,k.viewportDrag){if(n&&!dt)return dt=!0,void(ct={x:e,y:t});dt=!1,H.send(v())}k.view_only||(ut=ut.concat(y(V.absX(e),V.absY(t))),l())},P=function(e,t){var n,a;return dt?(n=ct.x-e,a=ct.y-t,ct={x:e,y:t},void V.viewportChange(n,a)):void(k.view_only||(ut=ut.concat(y(V.absX(e),V.absY(t)))))},d=function(){var e,t,n,l,o,r,u,c,p,h,g,b,y,w,A,C,_,D,P,F,T;switch(L){case"ProtocolVersion":if(H.rQlen()<12)return i("Incomplete protocol version");switch(l=H.rQshiftStr(12).substr(4,7),Util.Info("Server ProtocolVersion: "+l),l){case"003.003":M=3.3;break;case"003.006":M=3.3;break;case"003.007":M=3.7;break;case"003.008":M=3.8;break;case"004.000":M=3.8;break;default:return i("Invalid server version "+l)}M>B&&(M=B),rt||(j=setInterval(function(){H.flush()},50)),o="00"+parseInt(M,10)+".00"+10*M%10,H.send_string("RFB "+o+"\n"),s("Security","Sent ProtocolVersion: "+o);break;case"Security":if(M>=3.7){if(c=H.rQshift8(),H.rQwait("security type",c,1))return!1;if(0===c)return e=H.rQshift32(),t=H.rQshiftStr(e),i("Security failure: "+t);for(R=0,u=H.rQshiftBytes(c),Util.Debug("Server security types: "+u),r=0;r<u.length;r+=1)u[r]>R&&u[r]<3&&(R=u[r]);if(0===R)return i("Unsupported security types: "+u);H.send([R])}else{if(H.rQwait("security scheme",4))return!1;R=H.rQshift32()}s("Authentication","Authenticating using scheme: "+R),d();break;case"Authentication":switch(R){case 0:return H.rQwait("auth reason",4)?!1:(e=H.rQshift32(),t=H.rQshiftStr(e),i("Auth failure: "+t));case 1:if(M>=3.8)return void s("SecurityResult");break;case 2:return 0===I.length?(s("password","Password Required"),void k.onPasswordRequired(x)):H.rQwait("auth challenge",16)?!1:(p=H.rQshiftBytes(16),h=a(I,p),H.send(h),void s("SecurityResult"));default:return void i("Unsupported auth scheme: "+R)}s("ClientInitialisation","No auth required"),d();break;case"SecurityResult":if(H.rQwait("VNC auth response ",4))return!1;switch(H.rQshift32()){case 0:break;case 1:if(M>=3.8){if(n=H.rQshift32(),H.rQwait("SecurityResult reason",n,8))return!1;t=H.rQshiftStr(n),i(t)}else i("Authentication failed");return;case 2:return i("Too many auth attempts")}s("ClientInitialisation","Authentication OK"),d();break;case"ClientInitialisation":H.send([k.shared?1:0]),s("ServerInitialisation","Authentication OK");break;case"ServerInitialisation":if(H.rQwait("server initialization",24))return!1;J=H.rQshift16(),et=H.rQshift16(),g=H.rQshift8(),b=H.rQshift8(),y=H.rQshift8(),F=H.rQshift8(),w=H.rQshift16(),A=H.rQshift16(),C=H.rQshift16(),_=H.rQshift8(),D=H.rQshift8(),P=H.rQshift8(),H.rQshiftStr(3),Util.Info("Screen: "+J+"x"+et+", bpp: "+g+", depth: "+b+", big_endian: "+y+", true_color: "+F+", red_max: "+w+", green_max: "+A+", blue_max: "+C+", red_shift: "+_+", green_shift: "+D+", blue_shift: "+P),0!==y&&Util.Warn("Server native endian is not little endian"),16!==_&&Util.Warn("Server native red-shift is not 16"),0!==P&&Util.Warn("Server native blue-shift is not 0"),T=H.rQshift32(),tt=H.rQshiftStr(T),k.true_color&&"Intel(r) AMT KVM"===tt&&(Util.Warn("Intel AMT KVM only support 8/16 bit depths. Disabling true color"),k.true_color=!1),V.set_true_color(k.true_color),V.resize(J,et),q.grab(),G.grab(),k.true_color?(X=4,Z=3):(X=1,Z=1),h=m(),h=h.concat(f()),h=h.concat(v()),ot.fbu_rt_start=(new Date).getTime(),H.send(h),setTimeout(E,k.check_rate),setTimeout(S,nt),k.encrypt?s("normal","Connected (encrypted) to: "+tt):s("normal","Connected (unencrypted) to: "+tt)}},c=function(){var e,t,n,a,l,o,r,s,u,d=!0;switch(e=Q.rects>0?0:H.rQshift8()){case 0:d=p();break;case 1:if(Util.Debug("SetColourMapEntries"),H.rQshift8(),l=H.rQshift16(),o=H.rQshift16(),H.rQwait("SetColourMapEntries",6*o,6))return!1;for(a=0;o>a;a+=1)r=H.rQshift16(),r=parseInt(r/256,10),s=parseInt(H.rQshift16()/256,10),u=parseInt(H.rQshift16()/256,10),V.set_colourMap([u,s,r],l+a);Util.Debug("colourMap: "+V.get_colourMap()),Util.Info("Registered "+o+" colourMap entries");break;case 2:Util.Debug("Bell"),k.onBell(x);break;case 3:if(Util.Debug("ServerCutText"),H.rQwait("ServerCutText header",7,1))return!1;if(H.rQshiftBytes(3),t=H.rQshift32(),H.rQwait("ServerCutText",t,8))return!1;n=H.rQshiftStr(t),k.clipboardReceive(x,n),k.onClipboard(x,n);break;default:i("Disconnected: illegal server message type "+e),Util.Debug("ws.rQslice(0,30):"+H.rQslice(0,30))}return d},p=function(){var e,t,n,a=!0;if(0===Q.rects){if(H.rQwait("FBU header",3))return H.rQunshift8(0),!1;H.rQshift8(),Q.rects=H.rQshift16(),Q.bytes=0,ot.cur_fbu=0,ot.fbu_rt_start>0&&(e=(new Date).getTime(),Util.Info("First FBU latency: "+(e-ot.fbu_rt_start)))}for(;Q.rects>0;){if("normal"!==L)return!1;if(H.rQwait("FBU",Q.bytes))return!1;if(0===Q.bytes){if(H.rQwait("rect header",12))return!1;if(t=H.rQshiftBytes(12),Q.x=(t[0]<<8)+t[1],Q.y=(t[2]<<8)+t[3],Q.width=(t[4]<<8)+t[5],Q.height=(t[6]<<8)+t[7],Q.encoding=parseInt((t[8]<<24)+(t[9]<<16)+(t[10]<<8)+t[11],10),k.onFBUReceive(x,{x:Q.x,y:Q.y,width:Q.width,height:Q.height,encoding:Q.encoding,encodingName:z[Q.encoding]}),!z[Q.encoding])return i("Disconnected: unsupported encoding "+Q.encoding),!1}if(ot.last_fbu=(new Date).getTime(),a=O[Q.encoding](),e=(new Date).getTime(),ot.cur_fbu+=e-ot.last_fbu,a&&($[Q.encoding][0]+=1,$[Q.encoding][1]+=1,ot.pixels+=Q.width*Q.height),(0===Q.rects||ot.pixels>=J*et)&&((Q.width===J&&Q.height===et||ot.fbu_rt_start>0)&&(ot.full_fbu_total+=ot.cur_fbu,ot.full_fbu_cnt+=1,Util.Info("Timing of full FBU, cur: "+ot.cur_fbu+", total: "+ot.full_fbu_total+", cnt: "+ot.full_fbu_cnt+", avg: "+ot.full_fbu_total/ot.full_fbu_cnt)),ot.fbu_rt_start>0&&(n=e-ot.fbu_rt_start,ot.fbu_rt_total+=n,ot.fbu_rt_cnt+=1,Util.Info("full FBU round-trip, cur: "+n+", total: "+ot.fbu_rt_total+", cnt: "+ot.fbu_rt_cnt+", avg: "+ot.fbu_rt_total/ot.fbu_rt_cnt),ot.fbu_rt_start=0)),!a)return a}return k.onFBUComplete(x,{x:Q.x,y:Q.y,width:Q.width,height:Q.height,encoding:Q.encoding,encodingName:z[Q.encoding]}),!0},O.RAW=function(){var e,t;return 0===Q.lines&&(Q.lines=Q.height),Q.bytes=Q.width*X,H.rQwait("RAW",Q.bytes)?!1:(e=Q.y+(Q.height-Q.lines),t=Math.min(Q.lines,Math.floor(H.rQlen()/(Q.width*X))),V.blitImage(Q.x,e,Q.width,t,H.get_rQ(),H.get_rQi()),H.rQshiftBytes(Q.width*t*X),Q.lines-=t,Q.lines>0?Q.bytes=Q.width*X:(Q.rects-=1,Q.bytes=0),!0)},O.COPYRECT=function(){var e,t;return H.rQwait("COPYRECT",4)?!1:(e=H.rQshift16(),t=H.rQshift16(),V.copyImage(e,t,Q.x,Q.y,Q.width,Q.height),Q.rects-=1,Q.bytes=0,!0)},O.RRE=function(){var e,t,n,a,l,o;if(0===Q.subrects){if(H.rQwait("RRE",4+X))return!1;Q.subrects=H.rQshift32(),e=H.rQshiftBytes(X),V.fillRect(Q.x,Q.y,Q.width,Q.height,e)}for(;Q.subrects>0&&H.rQlen()>=X+8;)e=H.rQshiftBytes(X),t=H.rQshift16(),n=H.rQshift16(),a=H.rQshift16(),l=H.rQshift16(),V.fillRect(Q.x+t,Q.y+n,a,l,e),Q.subrects-=1;return Q.subrects>0?(o=Math.min(lt,Q.subrects),Q.bytes=(X+8)*o):(Q.rects-=1,Q.bytes=0),!0},O.HEXTILE=function(){var e,t,n,a,l,o,r,s,u,d,c,p,h,m,f,g,v,b=H.get_rQ(),y=H.get_rQi();for(0===Q.tiles&&(Q.tiles_x=Math.ceil(Q.width/16),Q.tiles_y=Math.ceil(Q.height/16),Q.total_tiles=Q.tiles_x*Q.tiles_y,Q.tiles=Q.total_tiles);Q.tiles>0;){if(Q.bytes=1,H.rQwait("HEXTILE subencoding",Q.bytes))return!1;if(e=b[y],e>30)return i("Disconnected: illegal hextile subencoding "+e),!1;if(t=0,a=Q.total_tiles-Q.tiles,l=a%Q.tiles_x,s=Math.floor(a/Q.tiles_x),o=Q.x+16*l,u=Q.y+16*s,r=Math.min(16,Q.x+Q.width-o),d=Math.min(16,Q.y+Q.height-u),1&e)Q.bytes+=r*d*X;else if(2&e&&(Q.bytes+=X),4&e&&(Q.bytes+=X),8&e){if(Q.bytes+=1,H.rQwait("hextile subrects header",Q.bytes))return!1;t=b[y+Q.bytes-1],Q.bytes+=16&e?t*(X+2):2*t}if(H.rQwait("hextile",Q.bytes))return!1;if(Q.subencoding=b[y],y+=1,0===Q.subencoding)1&Q.lastsubencoding?Util.Debug("     Ignoring blank after RAW"):V.fillRect(o,u,r,d,Q.background);else if(1&Q.subencoding)V.blitImage(o,u,r,d,b,y),y+=Q.bytes-1;else{if(2&Q.subencoding&&(Q.background=b.slice(y,y+X),y+=X),4&Q.subencoding&&(Q.foreground=b.slice(y,y+X),y+=X),V.startTile(o,u,r,d,Q.background),8&Q.subencoding)for(t=b[y],y+=1,p=0;t>p;p+=1)16&Q.subencoding?(n=b.slice(y,y+X),y+=X):n=Q.foreground,c=b[y],y+=1,h=c>>4,m=15&c,f=b[y],y+=1,g=(f>>4)+1,v=(15&f)+1,V.subTile(h,m,g,v,n);V.finishTile()}H.set_rQi(y),Q.lastsubencoding=Q.subencoding,Q.bytes=0,Q.tiles-=1}return 0===Q.tiles&&(Q.rects-=1),!0},A=function(e){var t=1,n=0;return n+=127&e[0],128&e[0]&&(t+=1,n+=(127&e[1])<<7,128&e[1]&&(t+=1,n+=e[2]<<14)),[t,n]},C=function(e){return";base64,"+Base64.encode(e)},S=function(){var e,t,n;if(n=V.get_context(),"normal"===L){for(t=Q.imgQ;t.length>0&&t[0].img.complete;)e=t.shift(),"fill"===e.type?V.fillRect(e.x,e.y,e.width,e.height,e.color):"rgb"===e.type?V.blitRgbImage(e.x,e.y,e.width,e.height,e.img.data,0):n.drawImage(e.img,e.x,e.y);setTimeout(S,nt)}},O.TIGHT=function(){return o(!1)},O.TIGHT_PNG=function(){return o(!0)},O.last_rect=function(){return Util.Debug(">> set_desktopsize"),Q.rects=0,Util.Debug("<< set_desktopsize"),!0},O.DesktopSize=function(){return Util.Debug(">> set_desktopsize"),J=Q.width,et=Q.height,V.resize(J,et),ot.fbu_rt_start=(new Date).getTime(),H.send(v()),Q.bytes=0,Q.rects-=1,Util.Debug("<< set_desktopsize"),!0},O.Cursor=function(){var e,t,n,a,l,o;return e=Q.x,t=Q.y,n=Q.width,a=Q.height,l=n*a*X,o=Math.floor((n+7)/8)*a,Q.bytes=l+o,H.rQwait("cursor encoding",Q.bytes)?!1:(V.changeCursor(H.rQshiftBytes(l),H.rQshiftBytes(o),e,t,n,a),Q.bytes=0,Q.rects-=1,!0)},O.JPEG_quality_lo=function(){Util.Error("Server sent jpeg_quality pseudo-encoding")},O.compress_lo=function(){Util.Error("Server sent compress level pseudo-encoding")},m=function(){var e;return e=[0],e.push8(0),e.push8(0),e.push8(0),e.push8(8*X),e.push8(8*Z),e.push8(0),e.push8(k.true_color?1:0),e.push16(255),e.push16(255),e.push16(255),e.push8(16),e.push8(8),e.push8(0),e.push8(0),e.push8(0),e.push8(0),e},f=function(){var e,t,n=[];for(t=0;t<U.length;t+=1)"Cursor"!==U[t][0]||k.local_cursor?n.push(U[t][1]):Util.Debug("Skipping Cursor pseudo-encoding");for(e=[2],e.push8(0),e.push16(n.length),t=0;t<n.length;t+=1)e.push32(n[t]);return e},g=function(e,t,n,a,l){"undefined"==typeof t&&(t=0),"undefined"==typeof n&&(n=0),"undefined"==typeof a&&(a=J),"undefined"==typeof l&&(l=et);var o;return o=[3],o.push8(e),o.push16(t),o.push16(n),o.push16(a),o.push16(l),o},v=function(){var e,t,n,a=V.getCleanDirtyReset(),l=[];for(t=a.cleanBox,t.w>0&&t.h>0&&(l=l.concat(g(1,t.x,t.y,t.w,t.h))),e=0;e<a.dirtyBoxes.length;e++)n=a.dirtyBoxes[e],l=l.concat(g(0,n.x,n.y,n.w,n.h));return l},b=function(e,t){var n;return n=[4],n.push8(t),n.push16(0),n.push32(e),n},y=function(e,t){var n;return n=[5],n.push8(it),n.push16(e),n.push16(t),n},w=function(e){var t,n,a;for(t=[6],t.push8(0),t.push8(0),t.push8(0),t.push32(e.length),a=e.length,n=0;a>n;n+=1)t.push(e.charCodeAt(n));return t},x.connect=function(e,t,n,a){return F=e,T=t,I=void 0!==n?n:"",N=void 0!==a?a:"",F&&T?void s("connect"):i("Must set host and port")},x.disconnect=function(){s("disconnect","Disconnecting")},x.sendPassword=function(e){I=e,L="Authentication",setTimeout(d,1)},x.sendCtrlAltDel=function(){if("normal"!==L||k.view_only)return!1;Util.Info("Sending Ctrl-Alt-Del");var e=[];e=e.concat(b(65507,1)),e=e.concat(b(65513,1)),e=e.concat(b(65535,1)),e=e.concat(b(65535,0)),e=e.concat(b(65513,0)),e=e.concat(b(65507,0)),e=e.concat(v()),H.send(e)},x.sendKey=function(e,t){if("normal"!==L||k.view_only)return!1;var n=[];"undefined"!=typeof t?(Util.Info("Sending key code ("+(t?"down":"up")+"): "+e),n=n.concat(b(e,t?1:0))):(Util.Info("Sending key code (down + up): "+e),n=n.concat(b(e,1)),n=n.concat(b(e,0))),n=n.concat(v()),H.send(n)},x.clipboardPasteFrom=function(e){"normal"===L&&H.send(w(e))},x.testMode=function(e){rt=!0,x.recv_message=H.testMode(e),E=function(){},x.connect=function(e,t,n){F=e,T=t,I=n,s("ProtocolVersion","Starting VNC handshake")}},t()}